#include "dialog.h"
#include "ui_dialog.h"

Dialog::Dialog(QWidget *parent, QStringList& list, QVector<Editor::Tab>& tabs) :
    QDialog(parent),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);

    ui->m_table->setRowCount(tabs.size());
    ui->m_table->setColumnCount(2);
    QHeaderView* header = ui->m_table->horizontalHeader();
    header->setSectionResizeMode(QHeaderView::Stretch);

    for(int i = 0; i < tabs.size(); i++)
    {
        if(tabs[i].m_file != nullptr)
            ui->m_table->setItem(i, 1, new QTableWidgetItem(QFileInfo(*tabs[i].m_file).absolutePath()));
        ui->m_table->setItem(i, 0, new QTableWidgetItem(list.at(i)));
    }

    connect(ui->m_buttons, SIGNAL(accepted()), SLOT(slotSave()));
    connect(ui->m_buttons, SIGNAL(rejected()), SLOT(slotDiscard()));
}

void Dialog::slotSave()
{
    emit signalSave();
    this->close();
}

void Dialog::slotDiscard()
{
    emit signalDiscard();
    this->close();
}

Dialog::~Dialog()
{
    delete ui;
}
